// Trace.cpp: Implementierung der Klasse CTrace.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Trace.h"
#include "TraceData.h"

extern CString g_csPath;
extern int     g_iTraceLevel;

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CTrace::CTrace()
{

}

CTrace::~CTrace()
{

}

void CTrace::WriteIt(WPARAM wParam, LPARAM lParam)
{
	// Na den Schreiben wir das mal auf die Platte
    TraceData* Buffer;
	Buffer = (TraceData*) lParam;
	if(g_iTraceLevel > 0)
	{
		int Listbox;
		CString csOutPut;
		CString csFileName;
		CString csFileDate;
		DWORD result=0;

		CString csTimeStamp = Buffer->m_TraceTime;
		csTimeStamp += Buffer->m_TraceString;
		Listbox = Buffer->m_ListBox;

		SYSTEMTIME time;
		GetLocalTime(&time);
		csFileDate.Format("%04u%02u%02u",time.wYear,time.wMonth,time.wDay);

		csFileName = g_csPath;
		csFileName += "SerialServer";
		csFileName += csFileDate;
		csFileName += ".log";
		csOutPut = Buffer->m_TraceTime;
		csOutPut += Buffer->m_TraceString;
		csOutPut += "\r\n";

		HANDLE hTraceFile = CreateFile(csFileName,GENERIC_WRITE,FILE_SHARE_READ | FILE_SHARE_WRITE,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
		DWORD dwSize = GetFileSize (hTraceFile, NULL);
		if ((dwSize/1024) >=  4096)
		{
			CloseHandle(hTraceFile);
			CString	csFileNameOld = g_csPath;
			csFileNameOld += "SerialServer";
			csFileNameOld += csFileDate;
			csFileNameOld += ".old";

			::CopyFile(csFileName,csFileNameOld,false);
			hTraceFile = CreateFile(csFileName,GENERIC_WRITE,FILE_SHARE_READ | FILE_SHARE_WRITE,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
		}
		SetFilePointer(hTraceFile,0,NULL,FILE_END);
		WriteFile(hTraceFile,csOutPut.operator LPCTSTR(),csOutPut.GetLength(),&result,NULL);
		CloseHandle(hTraceFile);
	}
	delete Buffer;
}

void CTrace::Alive(WPARAM wParam, LPARAM lParam)
{
	// Zur Zeit ohne belang
}
